"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var React = require("react");
var ReactDOM = require("react-dom");
var velocity_react_1 = require('velocity-react');
var VelocityDialog = (function (_super) {
    __extends(VelocityDialog, _super);
    function VelocityDialog() {
        _super.call(this);
        this.state = { isOpen: false, isRendered: false };
        this.animationDuration = 500;
    }
    VelocityDialog.prototype.createPortal = function () {
        var node = this.portalNode;
        if (node == null) {
            this.portalNode = node = document.createElement('div');
            this.portalNode.classList.add('dialog-host');
            node.id = "dialog-layer";
            document.body.appendChild(node);
        }
    };
    VelocityDialog.prototype.componentWillMount = function () {
        this.createPortal();
    };
    VelocityDialog.prototype.componentWillUnmount = function () {
        this.unmountPortalNode();
    };
    VelocityDialog.prototype.componentWillReceiveProps = function (newProps) {
        var _this = this;
        console.log("got props: " + (newProps.isOpen ? 'open!' : 'close'));
        if (newProps.isOpen !== this.state.isOpen) {
            this.setState({ isOpen: newProps.isOpen, isRendered: newProps.isOpen ? true : this.state.isRendered }, function () {
                _this.renderToPortal(_this.renderDialog(newProps.children));
            });
        }
        else {
            this.renderToPortal(this.renderDialog(newProps.children));
        }
    };
    VelocityDialog.prototype.componentDidMount = function () {
        this.renderToPortal(this.renderDialog(this.props.children));
    };
    VelocityDialog.prototype.animationComplete = function () {
        var _this = this;
        console.log('complete');
        if (!this.state.isOpen) {
            this.setState({ isRendered: false }, function () {
                _this.renderToPortal(_this.renderDialog(_this.props.children));
            });
        }
    };
    VelocityDialog.prototype.renderDialog = function (children) {
        return (React.createElement(velocity_react_1.VelocityComponent, {duration: this.animationDuration, animation: { opacity: this.state.isOpen ? 1 : 0 }, complete: this.animationComplete.bind(this)}, React.createElement("div", null, this.state.isRendered && React.createElement("div", {className: "dialog-layer"}, React.createElement("div", {className: "dialog"}, this.props.children)), !this.state.isRendered && React.createElement("noscript", null))));
    };
    VelocityDialog.prototype.renderToPortal = function (element) {
        if (element === null) {
            element = React.DOM.noscript();
        }
        ReactDOM.unstable_renderSubtreeIntoContainer(this, element, this.portalNode);
    };
    VelocityDialog.prototype.unmountPortalNode = function () {
        var unmounted = ReactDOM.unmountComponentAtNode(this.portalNode);
        if (unmounted) {
            document.body.removeChild(this.portalNode);
        }
        delete this.portalNode;
        return unmounted;
    };
    VelocityDialog.prototype.render = function () {
        return null;
    };
    return VelocityDialog;
}(React.Component));
exports.VelocityDialog = VelocityDialog;
