"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var React = require("react");
var _ = require("underscore");
var icon_1 = require('./../display/icon');
var grid_1 = require('./../layout/grid');
var DropdownSelect = (function (_super) {
    __extends(DropdownSelect, _super);
    function DropdownSelect() {
        _super.call(this);
        this.id = "dropdown-select-" + Math.random;
        this.minimumLength = 2;
        this.state = { filteredOptions: [], query: "", open: false, selectedValue: null };
    }
    DropdownSelect.prototype.filter = function (query) {
        if (query.length <= this.minimumLength) {
            return this.props.options;
        }
        var q = query.toLowerCase();
        return _.reject(this.props.options, function (o) { return o.label.toLowerCase().indexOf(q) === -1; });
    };
    DropdownSelect.prototype.focusInput = function () {
        var _this = this;
        this.setState({ open: true }, function () {
            document.getElementById(_this.id).focus();
        });
    };
    DropdownSelect.prototype.componentWillMount = function () {
        this.setState({ filteredOptions: this.props.options });
    };
    DropdownSelect.prototype.checkKey = function (e) {
        if (e.keyCode === 38) {
        }
        if (e.keyCode === 40) {
        }
    };
    DropdownSelect.prototype.render = function () {
        var _this = this;
        var filtered = this.filter(this.state.query);
        return (React.createElement("div", {className: "dropdown-select"}, React.createElement(grid_1.Grid, {className: "dropdown-value-display"}, React.createElement(grid_1.Row, null, React.createElement(grid_1.Col, {onClick: function () { return _this.focusInput(); }}, this.state.selectedValue ? React.createElement("div", null, this.state.selectedValue.label) : React.createElement("div", {className: "placeholder"}, this.props.placeholder)), React.createElement(grid_1.Col, {fixed: true, className: "clear-selected", onClick: function () { return _this.setState({ selectedValue: null, open: false, query: "", filteredOptions: _this.props.options }); }}, React.createElement(icon_1.Icon, {icon: icon_1.Icon.Icomoon.cross})))), this.state.open &&
            React.createElement("div", {className: "dropdown-select-list-wrapper"}, React.createElement("input", {type: "text", id: this.id, onKeyUp: function (e) { return _this.checkKey(e); }, defaultValue: this.props.value, onChange: function (e) { return _this.setState({ query: e.target.value }); }, placeholder: "start typing to filter results..."}), React.createElement("div", {className: "dropdown-select-list"}, filtered.map(function (o) { return React.createElement("div", {className: "dd-list-item" + (_this.state.selectedValue ? (o.id === _this.state.selectedValue.id ? ' selected' : '') : ''), onClick: function () { return _this.setState({ selectedValue: o, open: false, query: "" }); }}, o.label); }), filtered.length === 0 && React.createElement("div", null, "No results...")))));
    };
    return DropdownSelect;
}(React.Component));
exports.DropdownSelect = DropdownSelect;
